#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>

typedef struct 
{
   // ...
} TASK_T;

typedef struct 
{
   // ...
} QUEUE_T;

void *worker(void *arg)
{
    QUEUE_T task_queue = (QUEUE_T *)arg;
    TASK_T task;

    while ( 1 )
    {
        task = get_task( task_queue ); // Blocking
        process( task );
        dump_results( task );
    }
}

int main(int argc, char *argv[])
{
    QUEUE_T queue;
    TASK_T task;
    pthread_t threads[NUMBER_OF_THREADS];
    int status, i;

    // Create pool of threads/workers
    for(i = 0; i < NUMBER_OF_THREADS; i++) 
    {
        status = pthread_create(&threads[i], NULL, &worker, (void *)&q);
        if (status != 0) {
            printf("Oops. pthread_create returned error code %d\n", status);
            exit(-1);
        }
    }

    while ( 1 )
    {
        task = receive_task(); // assume it blocks until a new task arrives
        add_to_queue( queue, task ); // append to the queue of pending tasks
    }

    // Cleanup (if the loop ever finished)
    for(i = 0; i < NUMBER_OF_THREADS; i++) {
        pthread_join(threads[i], NULL);
    }

    pthread_exit(NULL);
}

